<!DOCTYPE html>
<html>
<head>
	<title></title>
</head>
<body>
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous">
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-ygbV9kiqUc6oa4msXn9868pTtWMgiQaeYH7/t7LECLbyPA2x65Kgf80OJFdroafW" crossorigin="anonymous"></script>
	<script>
		let customers = [
			{id:1,name:'Vivek', email:'vivek@abc.com', phone:'8989389333',address:"Singapore"},
			{id:2,name:'Dev', email:'dev@abc.com', phone:'866u389333',address:"India"},
			{id:3,name:'Ameer', email:'ameer@abc.com', phone:'877779333',address:"Asia"}
		]; //object
		
        const saveCustomers = (customers) => {
            // localStorage.setItem("key","value")
            localStorage.setItem("_customers",JSON.stringify(customers));
        }
        let selectedCustomerId=0;
		generateNextId= ()=>{
			let numberArray = customers.map(item=>{return item.id});
			console.log(numberArray);
			//spread operator
			let max = Math.max(...numberArray);
			return max +1;
		}
		if(localStorage.getItem("_customers") != null){
            try {
                customers = JSON.parse(localStorage.getItem("_customers"))
            } catch (error) {
                
            }
        }
        
        let addUpdateCustomer = () => {
			var name = document.getElementById('name').value;
			document.getElementById('name').value = '';

            var email = document.getElementById('email').value;
			document.getElementById('email').value = '';

            var phone = document.getElementById('phone').value;
			document.getElementById('phone').value = '';

            var address = document.getElementById('address').value;
			document.getElementById('address').value = '';
			
            if(document.getElementById('add').value == "Update"){
                document.getElementById('add').value="Add";
                let list = customers.filter((item)=>(item.id == selectedCustomerId));
                if(list.length > 0){
                    let record = list[0];
                    record.name = name;
                    record.email = email;
                    record.phone = phone;
                    record.address = address;
                }
            }else{
                var customer = {id:Date.now(), name,email,phone,address }
                customers.push(customer);
            }
			saveCustomers(customers);
            updateGUI(customers);
		}

		var updateGUI = function(customers){
			//JSON.stringify(s);
			const result = document.getElementById("result"); //result is the list
			result.innerHTML = "";//make it blank
			editRecord = function(i){
					console.log(" Want to edit ",customers[i]);
                    document.getElementById('name').value = customers[i].name;
                    document.getElementById('email').value = customers[i].email;
                    document.getElementById('phone').value = customers[i].phone;
                    document.getElementById('address').value = customers[i].address;
                    document.getElementById('add').value = "Update";
                    selectedCustomerId = customers[i].id;
					//customers = customers.filter((item) => (item.id != customers[i].id));
					//customers = customers.filter(function(item){return (item != customers[i])});
					updateGUI(customers);
				}
			deleteRecord = function(i){
					console.log(" Want to delete "+customers[i]);
					customers = customers.filter((item) => (item.id != customers[i].id));
                    saveCustomers(customers);
					//customers = customers.filter(function(item){return (item != customers[i])});
					updateGUI(customers);
				}
			for (let i = 0; i < customers.length; i++ ) {
				result.innerHTML+=	`<tr>
					<th scope="row">${customers[i].id}</th>
					<td>${customers[i].name}</td>
					<td>${customers[i].email}</td>
					<td>${customers[i].phone}</td>
					<td>${customers[i].address}</td>
					<td><button class="btn btn-info" onclick='editRecord(`+i+`)' >Edit</button></td>
					<td><button class="btn btn-danger" onclick='deleteRecord(`+i+`)' >Delete</button></td>
				</tr>`;
			}
		}
		let removeWord = () => {
			//how js works
			let temp = [];
			var word = document.getElementById('newWord').value;
			if(word === ""){
				words.pop();
			} else{
				customers = customers.filter(function(item){return (item != word)});
                saveCustomers(customers);
			 console.log("Assignment remove :"+word);
			}
			
			updateGUI(customers);
		}
		var doSearch = () =>{
			var field = document.getElementById('field').value;
			var searchText = document.getElementById('searchText').value;
			console.log("field::"+field);
			console.log("searchText::"+searchText);
			if(searchText.length ==0){
				updateGUI(customers);
			}else{
				searchText = searchText.toLowerCase();
				let temp = customers.filter((item)=>(item[field].toLowerCase().startsWith(searchText)))
				updateGUI(temp);
			}
		}

	</script>
	<div style="margin-left:15px;">
	<h1> Customer App</h1>
	<input id="name" placeholder="Name" type="" name="" value=""> <br/> <br/>
	<input id="email" placeholder="Email" type=""  value=""> <br/> <br/>
	<input id="phone" placeholder="Phone" type=""  value=""> <br/> <br/>
	<input id="address" placeholder="Address" type=""  value=""> <br/> <br/>

	<input id="add" onclick="addUpdateCustomer()" type="button" name="" value="Add"> | 
	<input onclick="removeWord()" type="button" name="" value="Cancel"> | 
	<input onclick="sortRecords('name')" type="button" name="" value="Sort by Name"> | 
	<input onclick="sortRecords('email')" type="button" name="" value="Sort by Email"> | 
	<input onclick="sortRecords('address')" type="button" name="" value="Sort by Address"> | 
	<br/><br/>
	<input id="searchText" placeholder="Search text" name="">
	<label>Search By</label>
	<select name="field" id="field">
	  <option value="name">Name</option>
	  <option value="email">Email</option>
	  <option value="phone">Phone</option>
	  <option value="address">Address</option>
	  <option value="id">Id</option>
	</select>
	<button onclick="doSearch()">Search</button> <br/><br/>
	 <br/> <br/>
	 <h4> LISTING</h4>
	 <table  class="table">
		<thead>
			<tr>
				<th>#</th>
				<th>Name</th>
				<th>Email</th>
				<th>Phone</th>
				<th>Address</th>
				<th>Edit</th>
				<th>Delete</th>
			</tr>
		</thead>
	<tbody id="result">
	</tbody>
</table><br/><br/>
</div>
	<script type="text/javascript">
		updateGUI(customers);
	</script>

</body>
</html>
